# checkupdate 

`checkupdate` is a tool to manage Fedora updates and integrate with Waybar. It provides a menu to download, install, and list updates. 

## Features 

- Check for updates using `pkcon` and `flatpak`
- Display update information in Waybar
- Provide a menu to manage updates ## Requirements - Python 3
- PackageKit
- libnotify
- Waybar 

## Installation 

### Using RPM Package 

1. **Build the RPM Package**:
    - Create a tarball of your project directory: ``` tar czvf checkupdate-2.0.tar.gz checkupdate/ ``` 
    - Place the `.spec` file and the source tarball in the appropriate directories in your RPM build environment (e.g., `~/rpmbuild/SPECS` and `~/rpmbuild/SOURCES`). 
    - Build the RPM package using `rpmbuild`: 
    ``` rpmbuild -ba ~/rpmbuild/SPECS/checkupdate.spec ``` 
    - This will generate the RPM package in the `~/rpmbuild/RPMS/noarch` directory. 
2. **Install the RPM Package**: 
    - Install the generated RPM package: ``` sudo rpm -ivh ~/rpmbuild/RPMS/noarch/checkupdate-2.0-1.noarch.rpm ``` 
    
### Manual Installation 

1. **Clone the Repository**: ``` git clone https://example.com/checkupdate.git cd checkupdate ``` 
2. **Install Dependencies**: ``` sudo dnf install python3 PackageKit libnotify ``` 
3. **Install the Scripts**: ``` sudo install -m 0755 checkupdate.py /usr/bin/checkupdate sudo install -d /usr/share/checkupdate sudo install -m 0644 check_for_updates.py /usr/share/checkupdate/ sudo install -m 0644 update_menu.py /usr/share/checkupdate/ ``` 

## Usage 

### Waybar Configuration 

Add the following configuration to your Waybar config file:

```json
    "custom/updater": { 
        "exec": "python3 /usr/share/checkupdate/check_for_updates.py", 
        "interval": 600, 
        "click-left": "python3 /usr/share/checkupdate/update_menu.py"
    }
``` 
### Running the Script Manually 

You can also run the script manually to check for updates:
``` python3 /usr/share/checkupdate/check_for_updates.py ``` 

## License 

This project is licensed under the GPLv3 License - see the [LICENSE](LICENSE) file for details. 

## Contributing 

1. Fork the repository
2. Create your feature branch (`git checkout -b feature/fooBar`)
3. Commit your changes (`git commit -am 'Add some fooBar'`)
4. Push to the branch (`git push origin feature/fooBar`)
5. Create a new Pull Request 

## Acknowledgments 
- Hat tip to anyone whose code was used
- Inspiration
- etc